#!/bin/bash
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:~/bin
export PATH

#######################################################
#               OPENVPN AUTO INSTALLER                #
#        Written by Dark Eagle @ Kaskus.co.id         #
#          Supported by Regolithmedia.co.id           #
#######################################################

if [ $(id -u) != "0" ]; then
    echo "Error: You must be root to run this script, please use root to install this script"
    exit 0
fi
clear

echo "================================================================================"
echo "         OPENVPN AUTO INSTALLER FOR CENTOS 5 & 6, DEBIAN 6, UBUNTU 10.10        "            
echo "================================================================================"
echo "                          Dark Eagle @ Kaskus.co.id"
echo "                      For more information please visit:"
echo "                      http://blog.regolithmedia.com/?p=25"
echo "================================================================================"

if [ -s /etc/redhat-release ]; then
	if [[ $(uname -i) == *_64* ]]; then
		lilib="lib64"
	else
		lilib="lib"
	fi
else
	lilib="lib"
fi
MARKAS=`ifconfig | grep 'inet addr:' | grep -v '127.0.0.1' | grep -v '127.0.0.2' | cut -d: -f2 | awk {'print $1'} | head -n 1`
mkdir -p /tmp/pkgs

GOO=0
YRT=1
while [ $GOO -eq "0" ]; do
	read -p "Please input your preferred openvpn username: " seruseru
	if [ "$seruseru" = "" ]; then
		if [ $YRT -lt 3 ]; then
			echo ""
			echo "You're not typing!"
			echo ""
			YRT=`expr $YRT + 1`
		else
			echo ""
			echo "You can try again later."
			echo ""
			exit 0
		fi
	else
		seruseru="$seruseru"
		GOO=1
	fi
done
echo ""

GOO=0
YRT=1
while [ $GOO -eq "0" ]; do
	read -p "Please input your preferred openvpn password: " ngepas
	if [ "$ngepas" = "" ]; then
		if [ $YRT -lt 3 ]; then
			echo ""
			echo "You're not typing!"
			echo ""
			YRT=`expr $YRT + 1`
		else
			echo ""
			echo "You can try again later."
			echo ""
			exit 0
		fi
	else
		ngepas="$ngepas"
		GOO=1
	fi
done
echo ""

GOO=0
YRT=1
while [ $GOO -eq "0" ]; do
	read -p "Please input 2 letter of your country code [US]: " country
	echo $country > /tmp/pkgs/temp
	if [ "$country" = "" ]; then
		if [ $YRT -lt 3 ]; then
			echo ""
			echo "You're not typing!"
			echo ""
			YRT=`expr $YRT + 1`
		else
			echo ""
			echo "You can try again later."
			echo ""
			exit 0
		fi
	else if [ $(cat /tmp/pkgs/temp | wc -m) -gt 3 ]; then
		if [ $YRT -lt 3 ]; then
			echo ""
			echo "Two letter only!"
			echo ""
			YRT=`expr $YRT + 1`
		else
			echo ""
			echo "You can try again later."
			echo ""
			exit 0
		fi
	else
		country="$country"
		GOO=1
	fi
	fi
done
echo ""

GOO=0
YRT=1
while [ $GOO -eq "0" ]; do
	read -p "Please input 2 letter of your state code [CA]: " state
	echo $state > /tmp/pkgs/temp
	if [ "$state" = "" ]; then
		if [ $YRT -lt 3 ]; then
			echo ""
			echo "You're not typing!"
			echo ""
			YRT=`expr $YRT + 1`
		else
			echo ""
			echo "You can try again later."
			echo ""
			exit 0
		fi
	else if [ $(cat /tmp/pkgs/temp | wc -m) -gt 3 ]; then
		if [ $YRT -lt 3 ]; then
			echo ""
			echo "Two letter only!"
			echo ""
			YRT=`expr $YRT + 1`
		else
			echo ""
			echo "You can try again later."
			echo ""
			exit 0
		fi
	else
		state="$state"
		GOO=1
	fi
	fi
done
echo ""

GOO=0
YRT=1
while [ $GOO -eq "0" ]; do
	read -p "Please input your locality [SanFrancisco]: " locality
	if [ "$locality" = "" ]; then
		if [ $YRT -lt 3 ]; then
			echo ""
			echo "You're not typing!"
			echo ""
			YRT=`expr $YRT + 1`
		else
			echo ""
			echo "You can try again later."
			echo ""
			exit 0
		fi
	else
		locality="$locality"
		GOO=1
	fi
done
echo ""

GOO=0
YRT=1
while [ $GOO -eq "0" ]; do
	read -p "Please input your common name [hostname]: " hoshos
	if [ "$hoshos" = "" ]; then
		if [ $YRT -lt 3 ]; then
			echo ""
			echo "You're not typing!"
			echo ""
			YRT=`expr $YRT + 1`
		else
			echo ""
			echo "You can try again later."
			echo ""
			exit 0
		fi
	else
		hoshos="$hoshos"
		GOO=1
	fi
done
echo ""

	get_char()
	{
	SAVEDSTTY=`stty -g`
	stty -echo
	stty cbreak
	dd if=/dev/tty bs=1 count=1 2> /dev/null
	stty -raw
	stty echo
	stty $SAVEDSTTY
	}
	echo ""
	echo "Press any key to start the installation..."
	char=`get_char`

if [ -s /etc/debian_version ]; then
if [[ $(cat /etc/debian_version) == *6.* ]]; then
cat >/etc/apt/sources.list<<EOF
deb http://ftp.debian.org/debian squeeze main contrib non-free

deb http://ftp.us.debian.org/debian/ squeeze main
deb-src http://ftp.us.debian.org/debian/ squeeze main

deb http://security.debian.org/ squeeze/updates main
deb-src http://security.debian.org/ squeeze/updates main

deb http://ftp.us.debian.org/debian/ squeeze-updates main
deb-src http://ftp.us.debian.org/debian/ squeeze-updates main
EOF
fi
fi

if [ -s /etc/redhat-release ]; then
	yum update -y
	yum install -y gcc make openssl openssl-devel pam-devel zip unzip
else if [ -s /etc/debian_version ]; then
	apt-get update -y
	apt-get install -y build-essential openssl libssl-dev libpam0g-dev zip unzip
fi
fi

wget -O /tmp/pkgs/lzo-2.06.tar.gz http://repo.regolithmedia.co.id/ovpn/lzo-2.06.tar.gz
tar -C /tmp/pkgs -zxvf /tmp/pkgs/lzo-2.06.tar.gz
cd /tmp/pkgs/lzo-2.06
./configure --prefix=/usr --libdir=/usr/$lilib
make
make install

wget -O /tmp/pkgs/openvpn-2.2.2.tar.gz http://repo.regolithmedia.co.id/ovpn/openvpn-2.2.2.tar.gz
tar -C /tmp/pkgs -zxvf /tmp/pkgs/openvpn-2.2.2.tar.gz
cd /tmp/pkgs/openvpn-2.2.2
./configure --prefix=/usr --libdir=/usr/$lilib
make
make install

mkdir -p /etc/openvpn
cp -r /tmp/pkgs/openvpn-2.2.2/easy-rsa /etc/openvpn

cd /tmp/pkgs/openvpn-2.2.2/plugin/auth-pam
make

if [ -s /etc/redhat-release ]; then
	if [[ $(uname -i) == *_64* ]]; then
		cp /tmp/pkgs/openvpn-2.2.2/plugin/auth-pam/openvpn-auth-pam.so /usr/lib64
	else
		cp /tmp/pkgs/openvpn-2.2.2/plugin/auth-pam/openvpn-auth-pam.so /usr/lib
	fi
else
	cp /tmp/pkgs/openvpn-2.2.2/plugin/auth-pam/openvpn-auth-pam.so /usr/lib
fi

cd /etc/openvpn/easy-rsa/2.0
chmod 755 *
source ./vars
./vars
./clean-all
./build-dh

cd /etc/openvpn/easy-rsa/2.0/keys
openssl genrsa -out ca.key 1024
openssl req -new -x509 -days 365 -key ca.key -out ca.crt -subj "/C=$country/ST=$state/L=$locality/CN=$hoshos"
openssl genrsa -out server.key 1024
openssl req -new -key server.key -out server.csr -subj "/C=$country/ST=$state/L=$locality/CN=server"
openssl x509 -req -days 365 -in server.csr -CA ca.crt -CAkey ca.key -set_serial 01 -out server.crt

echo "#The first three lines would be your server ip, port target, and protocol
local $MARKAS
port 1194
proto udp

#We use TUN driver and other standard TUN configuration
dev tun
tun-mtu 1500
tun-mtu-extra 32
mssfix 1450

#This is where the required certificates and keys need are located
ca /etc/openvpn/easy-rsa/2.0/keys/ca.crt
cert /etc/openvpn/easy-rsa/2.0/keys/server.crt
key /etc/openvpn/easy-rsa/2.0/keys/server.key
dh /etc/openvpn/easy-rsa/2.0/keys/dh1024.pem

#Authentication with SSH login
plugin /usr/$lilib/openvpn-auth-pam.so /etc/pam.d/login
client-cert-not-required
username-as-common-name

#Example of local IP address we use for client
server 10.2.3.0 255.255.255.0

#Tunnel all of client's network activity via OpenVPN server
push \"redirect-gateway def1\"

#Or add local flag if the clients are on the same wireless subnet
#push \"redirect-gateway local def1\"
#Add DNS extra for OpenVPN route
#You can add more like from GoogleDNS, OpenDNS, etc.
push \"dhcp-option DNS 208.67.222.222\"
push \"dhcp-option DNS 4.2.2.1\"

#Ping every 5 seconds, assuming that network
#will be down in 30 seconds
keepalive 5 30

#User LZO Compression (faster)
comp-lzo

#Avoid Ping from restarting
persist-key

#Avoid TUN/TAP driver from restarting
persist-tun

#Write status of the connection
status 1194-udp.log

#Normal output verbosity level
verb 3" >> /etc/openvpn/1194-udp.conf

openvpn /etc/openvpn/1194-udp.conf &
bg

echo 1 > /proc/sys/net/ipv4/ip_forward
iptables -t nat -A POSTROUTING -s 10.2.3.0/24 -j SNAT --to $MARKAS

useradd -s /bin/false $seruseru
echo $seruseru:$ngepas|chpasswd

echo "client
dev tun
proto udp
remote $MARKAS 1194
resolv-retry infinite
nobind
tun-mtu 1500
tun-mtu-extra 32
mssfix 1450
persist-key
persist-tun
ca ca.crt
auth-user-pass
comp-lzo
verb 3" > /tmp/pkgs/1194-udp.ovpn
cp /etc/openvpn/easy-rsa/2.0/keys/ca.crt /tmp/pkgs
cd /tmp/pkgs
zip config.zip 1194-udp.ovpn ca.crt
mv config.zip /root

rm -rf /tmp/pkgs
echo ""
echo "================================================================="
echo "OpenVPN Server has been successfully installed"
echo "Now install OpenVPN GUI for Windows, get the installer from:"
echo "http://repo.regolithmedia.co.id/ovpn/openvpn-2.2.2-install.exe"
echo "After that download config.zip in your \"/root\" directory"
echo "Extract it to your OpenVPN Windows \"config\" folder"
echo ""
echo "Default Port: UDP 1194"
echo "Username: $seruseru"
echo "Password: $ngepas"
echo ""
echo "More info at: http://blog.regolithmedia.com/?p=25"
echo "================================================================="
echo ""
echo "BROUGHT TO YOU BY REGOLITH MEDIA"